<!DOCTYPE html>
<html lang="en">
<head>
  <title>67.S10</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>
<body>

<div class="container">
  <h2 style="text-align: center;">Quản trị Voucher</h2>
	<div class="jumbotron container">
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="voucher-code">Mã Voucher</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-voucher-code" name="vouchercodes" placeholder="Voucher code"
			class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="discount">Phần trăm giảm giá</label>
		</div>
		<div class="col-sm-9">
		  <input type="number" id="input-discount" name="discount" placeholder="Discount" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="note">Ghi chú</label>
		</div>
		<div class="col-sm-9">
		  <input type="text" id="input-note" name="note" placeholder="Note" class="form-control">
		</div>
	  </div>
	  <!-- <div class="row form-group">
		<div class="col-sm-3">
		  <label for="createDate">Ngày Tạo</label>
		</div>
		<div class="col-sm-9">
		  <input type="date" id="input-createDate" name="createDate" placeholder="Create Date" class="form-control">
		</div>
	  </div>
	  <div class="row form-group">
		<div class="col-sm-3">
		  <label for="updateDate">Ngày sửa</label>
		</div>
		<div class="col-sm-9">
		  <input type="date" id="input-updateDate" name="updateDate" placeholder="Update Date" class="form-control">
		</div>
	  </div> -->
	  <div class="row pull-right">
		<div class="col-sm-12">
		  <button id="save_data" class="btn btn-info">Save Data</button>
		</div>
	  </div>
	</div>
  <table class="table table-bordered table-striped table-hover" id="table-order">
    <thead>
      <tr>
        <th>STT</th>
        <th>Mã giảm giá</th>
        <th>Phần trăm giảm giá</th>
        <th>Ghi Chú</th>
        <th>Ngày tạo</th>
        <th>Ngày cập nhật</th>
		<th>Action</th>
      </tr>
  </table>

  <div class="modal fade" id="deleteCourseModal" tabindex="-1" role="dialog" aria-labelledby="deleteCourseModalLabel" aria-hidden="true">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title" id="deleteCourseModalLabel">Delete Course?</h5>
          <button type="button" class="close" data-dismiss="modal" aria-label="Close">
            <span aria-hidden="true">&times;</span>
          </button>
        </div>
        <div class="modal-body">
          Are you sure you want to delete this course?
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
          <button type="button" class="btn btn-danger" id="deleteCourseBtn">Delete</button>
        </div>
      </div>
    </div>
  </div>
</div>
<script>

/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */

const host = "http://localhost:8080/api";
const gVOUCHERS_URL = `${host}/voucher-list`;
const gVOUCHER_URL = `${host}/vouchers/`;
const gUPDATE_VOUCHER_URL = `${host}/update-voucher/`;
const gDELETE_VOUCHER_URL = `${host}/delete-voucher/`;
const gCREATE_VOUCHER_URL = `${host}/create-voucher/`;

const gCOLUMN_ID = {
    stt: 0,
    maVoucher: 1,
    phanTramGiamGia: 2,
    ghiChu: 3,
    ngayTao: 4,
    ngayCapNhat:5,
	action:6

}
const gCOL_NAME = [
    "id",
    "maVoucher",
    "phanTramGiamGia",
    "ghiChu",
    "ngayTao",
    "ngayCapNhat",
]
//Hàm chính để load html hiển thị ra bảng
class Main {
    constructor() {
        $(document).ready(() => {
            this.vOrderList = new RenderPage()
            this.vOrderList.renderPage()

        })
    }

}
new Main()
/*** REGION 2 - vùng để render ra bảng*/
class RenderPage {
    constructor() {
        this.vApi = new CallApi()
		this.vModal = new Modal()
    }

	_onEventListner() {
		$("#save_data").on("click", ()=> {
			const vVoucher = {
		    maVoucher: $("#input-voucher-code").val(),
			phanTramGiamGia: $("#input-discount").val(),
			ghiChu: $("#input-note").val()	
		}
		const url = window.location.href;
		const segments = url.split('/');
		const vId = segments[segments.length - 1];
		if(vId) {
			this._updateVoucher(vId,vVoucher)
		}else {
			this._createVoucher(vVoucher)
		}
		
 	 });
	}

    //Hàm gọi api lấy danh sách đơn hàng
    _getVoucherList() {
        this.vApi.onGetVoucherClick((paramVoucher) => {
            console.log(paramVoucher)
            this._createOrderTable(paramVoucher)
        })
    }

	_getVoucherById(paramId) {
        this.vApi.onGetVoucherByIdClick(paramId,(paramVoucher) => {
			$('#input-voucher-code').val(paramVoucher.maVoucher);
			$('#input-discount').val(paramVoucher.phanTramGiamGia);
			$('#input-note').val(paramVoucher.ghiChu);
           
        })
    }

	_updateVoucher(paramId, paramVoucher) {
		this.vApi.onUpdateVoucherClick(paramId,paramVoucher,(paramUpdateVoucher)=> {
			console.log(paramUpdateVoucher)
		})
    }

	_createVoucher(paramVoucher) {
		this.vApi.onCreateVoucherClick(paramVoucher)
	}
    //Hàm tạo các thành phần của bảng
    _createOrderTable(paramVoucher) {
        let stt = 0
        if ($.fn.DataTable.isDataTable('#table-order')) {
            $('#table-order').DataTable().destroy();
        }
        const vOrderTable = $("#table-order").DataTable({
            // Khai báo các cột của datatable
            columns: [
                { "data": gCOL_NAME[gCOLUMN_ID.stt] },
                { "data": gCOL_NAME[gCOLUMN_ID.maVoucher] },
                { "data": gCOL_NAME[gCOLUMN_ID.phanTramGiamGia] },
                { "data": gCOL_NAME[gCOLUMN_ID.ghiChu] },
                { "data": gCOL_NAME[gCOLUMN_ID.ngayTao] },
                { "data": gCOL_NAME[gCOLUMN_ID.ngayCapNhat] },
				{ "data": gCOL_NAME[gCOLUMN_ID.action] },
        
            ],
            columnDefs: [   
				{
                    targets: gCOLUMN_ID.stt,
                    render: (data, type, row, meta) => {
                        if (type === 'display') {
                            return meta.row + 1;
                        } else {
                            return data;
                        }
                    }
                },
				{
                    targets: gCOLUMN_ID.action,
                    defaultContent: `<button class='btn btn-sm  btn-danger px-4 delete'>Xóa</button>`,
                    createdCell: (cell, cellData, rowData, rowIndex, colIndex) => {
                            $(cell).on("click", ".delete", () => {
								const id = vOrderTable.row(rowIndex).data().id;
								this.vModal.openModal(id)
                            })
                        }

            	 }

			],

        });
        vOrderTable.clear() // xóa toàn bộ dữ liệu trong bảng
        vOrderTable.rows.add(paramVoucher) // cập nhật dữ liệu cho bảng
        vOrderTable.draw()// hàm vẻ lại bảng

		$('#table-order tbody').on('click', 'tr', (event) => {
		const id = vOrderTable.row($(event.target).closest('tr')).data().id;
		const currentPageURL = window.location.href; 
		const urlSegments = currentPageURL.split('/');

		const lastSegment = urlSegments[urlSegments.length - 1];
		if (!isNaN(lastSegment)) {
		urlSegments.pop();
		}
		urlSegments.push(id);
		const updatedURL = urlSegments.join('/'); 

		window.history.pushState(null, null, updatedURL);
		this._getVoucherById(id);
});

    }

    // Hàm sẽ được gọi ở class Main 
    renderPage() {
        this._getVoucherList()
		this._onEventListner()
    }
}
/*** REGION 3 - vung hoi Modal*/
	class Modal {
		constructor() {
			this.vApi = new CallApi()
		}

		_deleteCourse(id) { 
        $("#deleteCourseBtn").on("click",()=> {
            this.vApi.onDeleteVoucherClick(id)
        })
    }
    openModal(id) {
            this._deleteCourse(id)
            $('#deleteCourseModal').modal('show');

  	  }
	}

/*** REGION 4 - vùng để gọi lên cơ sở dữ liệu lấy đa ta về*/
class CallApi {
    constructor() {
		
    }
    onGetVoucherClick(paramCallbackFn) {
     
        $.ajax({
            url: gVOUCHERS_URL,
            method: "GET",
            success: function (data) {
                paramCallbackFn(data)
            },
            error: function (jqXHR, textStatus, errorThrown) {
               
            }
        });

		
    }

	onGetVoucherByIdClick(voucherId,paramCallbackFn) {	
	 $.ajax({
		 url: `${gVOUCHER_URL}/${voucherId}`,
		 method: "GET",
		 success: function (data) {
			 paramCallbackFn(data)
		 },
		 error: function (jqXHR, textStatus, errorThrown) {
			
		 }
	 })
	}

	onCreateVoucherClick(voucher) {	
	 $.ajax({
		 url: `${gCREATE_VOUCHER_URL}`,
		 method: "POST",
		 data: JSON.stringify(voucher), 
   		 contentType: "application/json", 
		 success: function (data) {
			 paramCallbackFn(data)
			 const render = new RenderPage()
			 render.renderPage()
		 },
		 error: function (jqXHR, textStatus, errorThrown) {
			
		 }
	 });
	}
	 onUpdateVoucherClick(voucherId, voucher,paramCallbackFn) {	
	 $.ajax({
		 url: `${gUPDATE_VOUCHER_URL}/${voucherId}`,
		 method: "POST",
		 data: JSON.stringify(voucher), 
   		 contentType: "application/json", 
		 success: function (data) {
			 paramCallbackFn(data)
			 const render = new RenderPage()
			 render.renderPage()
		 },
		 error: function (jqXHR, textStatus, errorThrown) {
			
		 }
	 });
	}

	onDeleteVoucherClick(voucherId) {	
	 $.ajax({
		 url: `${gDELETE_VOUCHER_URL}/${voucherId}`,
		 method: "POST",
		 success: function (data) {
			 const render = new RenderPage()
			 render.renderPage()
			 $('#deleteCourseModal').modal('hide');
		 },
		 error: function (jqXHR, textStatus, errorThrown) {
			
		 }
	 });
	}
}
</script>
</body>
</html>
